unit Unit1;

interface

{$I RV_Defs.inc}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RVStyle, gtClasses, gtCstDocEng, gtCstPlnEng,
  gtCstPDFEng, gtExPDFEng, gtPDFEng, RichViewActions, ActnList, PtblRV,
  RVScroll, RichView, RVEdit, Menus, gtRTFEng, gtCstHTMLEng, gtExHTMLEng,
  gtHTMLEng,Printers, RVOfficeCnv,RVTable,RVItem , RVTypes, RVuni,
  CRVPP, RVPP,
  RVLinear,RVGetText,CRVData,CRVFData,RVReport,StrUtils, DB, ADODB, RVNormalize,
  OleCtrls, ComObj,ActiveX;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
// Converting text from String to internal representation
function ConvertStringToItemText(const Text: String;
  UnicodeItem: Boolean; CodePage: Cardinal): TRVRawByteString;
begin
  {$IFDEF RVUNICODESTR} // <-- declared in RV_Defs.inc
  if UnicodeItem then
    Result := RVU_GetRawUnicode(Text)
  else
    Result := TRVAnsiString(Text);
  {$ELSE}
  if UnicodeItem then
    Result := RVU_AnsiToUnicode(CodePage, Text)
  else
    Result := Text;
  {$ENDIF}
end;

// Use as it is, do not modify
procedure InsertMultilineText(RVData: TCustomRVData;
  var ItemNo, Pos: Integer; const Value: String);
var s1, s2, s3, s4: String;
    sl: TStringList;
    i, StyleNo, ParaNo: Integer;
    Unicode: Boolean;
    CodePage: TRVCodePage;
    {.....................................}
    procedure InsertItem(item: TCustomRVItemInfo; const s: String;
      ItemNo: Integer; Unicode: Boolean);
    var sr: TRVRawByteString;
    begin
      if Unicode then
        item.ItemOptions := item.ItemOptions+[rvioUnicode];
      sr := ConvertStringToItemText(s, Unicode, CodePage);
      item.Inserting(RVData, sr, False);
      RVData.Items.InsertObject(ItemNo, sr, item);
      item.Inserted(RVData, ItemNo);
    end;
    {.....................................}
    procedure InsertString(var ItemNo: Integer; s: String; FromNewLine: Boolean);
    var p: Integer;
        s2: String;
        item: TRVTextItemInfo;
        tabitem: TRVTabItemInfo;
        Added: Boolean;
    begin
      Added := False;
      p := System.Pos(#9, s);
      while p>0 do begin
        s2 := Copy(s, 1, p-1);
        if s2<>'' then begin
          item := RichViewTextItemClass.Create(RVData);
          item.StyleNo := StyleNo;
          item.ParaNo := ParaNo;
          if not FromNewLine then
            item.SameAsPrev := True;
          FromNewLine := False;
          InsertItem(item, s2, ItemNo, Unicode);
          inc(ItemNo);
        end;
        tabitem := TRVTabItemInfo.Create(RVData);
        tabitem.StyleNo := rvsTab;
        tabitem.TextStyleNo := StyleNo;
        tabitem.ParaNo := ParaNo;
        if not FromNewLine then
          tabitem.SameAsPrev := True;
        FromNewLine := False;
        InsertItem(tabitem, '', ItemNo, False);
        inc(ItemNo);
        s := Copy(s, p+1, Length(s));
        p := System.Pos(#9, s);
        Added := True;
      end;
      if (s<>'') or (not Added and FromNewLine) then begin
        item := RichViewTextItemClass.Create(RVData);
        item.StyleNo := StyleNo;
        item.ParaNo := ParaNo;
        if not FromNewLine then
          item.SameAsPrev := True;
        InsertItem(item, s, ItemNo, Unicode);
        inc(ItemNo);
      end;
    end;
    {.....................................}
    procedure ReplaceTabs;
    var s, Spaces: String;
        i, j, Count: Integer;
    begin
      Count := RVData.GetRVStyle.SpacesInTab;
      if Count=0 then
        exit;
      SetLength(Spaces, Count);
      for i := 1 to Count do
        Spaces[i] := ' ';
      for i := 0 to sl.Count-1 do begin
        s := sl[i];
        for j := Length(s) downto 1 do
          if s[j]=#9 then begin
            Delete(s, j, 1);
            Insert(Spaces, s, j);
          end;
        sl[i] := s;
      end;
    end;
    {.....................................}


begin
  if Value='' then
    exit;
  s1 := RVData.GetItemText(ItemNo);
  s2 := Copy(s1, Pos, Length(s1));
  s1 := Copy(s1, 1, Pos-1);
  sl := TStringList.Create;
  sl.Text := Value;
  { workaround - TStringList ignores the last cr lf }
  if (Length(Value)>1) and
     (Value[Length(Value)-1]=#13) and (Value[Length(Value)]=#10) then
    sl.Add('');
  { end of workaround }
  ReplaceTabs;

  i := System.Pos(#9, sl[0]);
  if (sl.Count=1) and (i=0) then begin
    RVData.SetItemText(ItemNo, s1+Value+s2);
    sl.Free;
    inc(Pos, Length(Value));
    exit;
  end;
  s3 := sl[0];
  s4 := '';
  if i>0 then begin
    s4 := Copy(s3, i, Length(s3));
    s3 := Copy(s3, 1, i-1);
  end;
  RVData.SetItemText(ItemNo, s1+s3);
  inc(Pos, Length(s3));
  StyleNo := RVData.GetItemStyle(ItemNo);
  ParaNo := RVData.GetItemPara(ItemNo);
  Unicode := rvioUnicode in RVData.GetItem(ItemNo).ItemOptions;
  CodePage := RVData.GetItemCodePage(ItemNo);
  inc(ItemNo);
  if sl.Count=1 then
    s4 := s4+s2;
  if s4<>'' then
    InsertString(ItemNo, s4, False);
  for i := 1 to sl.Count-1 do begin
    s1 := sl[i];
    if i=sl.Count-1 then
      s1 := s1+s2;
    InsertString(ItemNo, s1, True);
  end;
  dec(ItemNo);
  Pos := RVData.GetOffsAfterItem(ItemNo)-Length(s2);
  sl.Free;
end;

// test
procedure TForm1.Button1Click(Sender: TObject);
var
  ItemNo,Pos :integer;
  strValue :string;
begin
  if RichViewEdit1.GetItemStyle(RichViewEdit1.CurItemNo)<0 then begin
    Beep;
    exit;
  end;
  ItemNo := RichViewEdit1.CurItemNo;
  Pos := RichViewEdit1.OffsetInCurItem;
  strValue := Memo1.Text ;
  InsertMultilineText(RichViewEdit1.RVData, ItemNo, Pos, strValue);
  RichViewEdit1.Format;
  RichViewEdit1.ClearUndo;
  RichViewEdit1.SetSelectionBounds(ItemNo, Pos, ItemNo, Pos);
  RichViewEdit1.SetFocus;
end;

end.
